-------------------------------------------------------------------------------
-- A super special addon for the Stormwind City Guard.
-------------------------------------------------------------------------------

local VERSION = GetAddOnMetadata( "SCGStatus", "Version" )
local Main = LibStub("AceAddon-3.0"):NewAddon( "SCGStatus", 
												"AceHook-3.0", "AceEvent-3.0" )
local AceConfig       = LibStub("AceConfig-3.0")

SCGStatus = Main
Main.version = VERSION

-------------------------------------------------------------------------------
DB_DEFAULTS = {
	char = {
		minimapicon = {
			hide = false
		}
	}
}

-------------------------------------------------------------------------------
-- Initialization.
--
function Main:OnInitialize()
	Main.MinimapButton.Init()
end

-------------------------------------------------------------------------------
-- Post-initialization
--
function Main:OnEnable()
	Main:CreateDB()
	Main.MinimapButton.OnLoad()
	
	Main.Status.Update()
	Main:RegisterEvent( "GUILD_ROSTER_UPDATE", "GuildRosterUpdate" )
	Main:GuildRosterUpdate()
end

-------------------------------------------------------------------------------
-- Event when guild status changes.
--
function Main:GuildRosterUpdate()
	
	Main.Status.Update()
	
	if Main.Roster.ui and Main.Roster.ui.frame:IsShown() then
		Main.Roster.Update()
	end
	
	if not Main.Status.OnDuty() then
		SCGS_Panel:Hide()
	else
		SCGS_Panel:Show()
		local status = Main.Status.Get():sub( 3 )
		SCGS_Panel.text:SetText( status )
	end
	
	
end

-------------------------------------------------------------------------------
function Main:CreateDB()
	
	local acedb = LibStub( "AceDB-3.0" )
	Main.db = acedb:New( "SCGStatusSaved", DB_DEFAULTS, true )
	Main.db.global.version = VERSION
	
end

-------------------------------------------------------------------------------
-- Slash command.
--
SlashCmdList["SCGSTATUS"] = function( msg ) 
	-- todo add slash command registration
	
end

